;this is a translation of an example that was included with "Precision Basic" by Epdel Systems
;Precision Basic was a basic interpreter for the CP/M operating system.
;there were no copyrights on the examples, so hopefully it's OK to post.
;this program computes the taylor coefficients of the function you enter.

;i changed all gosub's to goto's, so if someone wants to re-write this as a procedure,
;there should be no problems.

;BTW, if you enter 0 for the number of coefficients, it will evaluate 
;the function you enter, so if someone can untangle this code, 
;it could be used as an eval function. 

;you need the pbAPM lib installed to compile
 
    OpenConsole()
   
    #m=60
    #max_terms=1000
    
    Dim c.qfloat(#max_terms+1)
    Dim e.l(200)
    Dim k.l(200)
    Dim o.l(#m)
    Dim v.l(#m)
    Dim go_sub.l(200)
    Dim s.qfloat(#m,#max_terms+1)
    DefType.qfloat ss,x,y,z,z1,z2,z3,z4,m2,zero,one,two,half,pi,e
    DefType.l i,oo,o1,o2,j,vv,kk,k1,k2,k3,k4,l,l2,m1,n,n1,ee,e3,e9,vc,go_sub_stack
    Dim a.s(26)
    aa.s
    
        
;   initialize Q variables

    Q_PI(pi)
    Q_E(e)
    Q_Val(zero,"0")
    Q_Val(one,"1")
    Q_Val(two,"2")
    Q_Div(one,two,half)
    go_sub_stack=0
    j = 0
    a(2) = "x": a(3) = "(": a(4) = "acos(": a(5) = "asin("
    a(6) = "atan(": a(7) = "cos(": a(8) = "cosh(": a(9) = "exp("
    a(10) = "log(": a(11) = "sin(": a(12) = "sinh(": a(13) = "sqrt("
    a(14) = "Tan(": a(15) = "Tanh(": a(16) = "-": a(17) = "+"
    a(21) = "+": a(22) = "-": a(23) = "*": a(24) = "/": a(25) = "^": a(26) = ")"
    ClearConsole()
    PrintN("")
    PrintN("          Program to expand f(x) into a Taylor series")
    PrintN("")
1:  Print("Enter by number the highest term to be calculated ")
    aa=Input()
    n=Val(aa)
    If n < 0: Goto 1:EndIf
    If n > #max_terms
      PrintN("")
      PrintN(Str(#max_terms)+" is maximum")
      Goto 1
    EndIf
    PrintN("")
    PrintN("specify f(x) by entering successive elements of f(x) by code below")
    PrintN("(entering a zero will delete the last f(x) element)")
    PrintN("")
    PrintN("C denotes any constant")
    j = 1: kk = 1: e9 = 0: e3 = 17
    PrintN("")
    Goto 3
2:  PrintN("")
    ClearConsole()
3:  Print("f(x)=")
    If j = 1: Goto 6:EndIf
    For i = 1 To j - 1
       ee = e(i)
       If ee <> 1: Goto 4:EndIf
       k1 = k(i)
       If Q_Equ(c(k1),zero)=0 ;c(k1)<>zero
         Q_Div(one,c(k1),m2)
         m1=Q_Cmp(m2,zero)
         Q_Abs(m2,m2)
       EndIf
       If Q_Equ(c(k1),pi)
         Print("Pi")
       ElseIf Q_Equ(c(k1),e)
         Print("E")
       ElseIf Q_IsInt(c(k1))
         Print(Str(Q_toInt(c(k1))))
       ElseIf Q_IsInt(m2)
         If m1<0
           aa="-1/"
         Else
           aa="1/"
         EndIf
         Print(aa+Str(Q_toInt(m2)))
       Else
         Print(Q_StrExp(c(k1), 3))
       EndIf
       Goto 5
4:     Print(a(ee))
5:   Next
6:  PrintN(""): PrintN("")
    If e3 = 6: Goto 8:EndIf
    Print("C X ( acos asin atan cos cosh exp  log sin sinh sqr  tan tanh")
    If e3 = 17
      PrintN("  -   +")
      Goto 7
    EndIf
    PrintN("")
7:  Print("1 2 3   4    5    6   7    8   9    10  11   12  13   14  15")
    If e3 = 17
      PrintN("   16  17")
      Goto 10
    EndIf
    PrintN("")
    Goto 10
8:  Print("+  -  *  /  ^  ")
    If e9 > 0
      PrintN(")")
      Goto 9
    EndIf
    PrintN("end of f(x)")
9:  Print("1  2  3  4  5")
    If e9 > 0
      PrintN("  6")
      Goto 10
    EndIf
    PrintN("           6")
10: Print("Enter code integer ")
    aa=Input()
    ee=Val(aa)
    If (ee < 0) Or (ee > e3): Goto 2:EndIf
    If ee > 0: Goto 13:EndIf
    If j = 1: Goto 2:EndIf
    j = j - 1
    ee = e(j)
    If ee < 21: Goto 11:EndIf
    e3 = 6
    If ee = 26: e9 = e9 + 1:EndIf
    Goto 2
11: If ee < 16: Goto 12:EndIf
    e3 = 17
    Goto 2
12: e3 = 17
    If (e(j - 1) = 16) Or (e(j - 1) = 17): e3 = 15:EndIf
    If ee = 1: kk = kk - 1:EndIf
    If ee >= 3: e9 = e9 - 1:EndIf
    Goto 2
13: If e3 = 6: Goto 17:EndIf
    If e3 = 15: Goto 14:EndIf
    If ee <= 15: Goto 14:EndIf
    e3 = 15
    Goto 19
14: If ee <> 1: Goto 15:EndIf
    PrintN("")
    Print("Enter constant ")
    aa=Input()
    If UCase(aa)="PI"
      Q_PI(c(kk))
    ElseIf UCase(aa)="E"
      Q_E(c(kk))
    Else  
      Q_Val(c(kk),aa)
    EndIf
    k(j) = kk: kk = kk + 1
    e3 = 6
    Goto 19
15: If ee <> 2: Goto 16:EndIf
    e3 = 6
    Goto 19
16: e9 = e9 + 1
    e3 = 17
    Goto 19
17: ee = ee + 20
    If ee <> 26: Goto 18:EndIf
    If e9 = 0: Goto 20:EndIf
    e9 = e9 - 1
    Goto 19
18: e3 = 17
19: e(j) = ee
    j = j + 1
    Goto 2
20: e(j) = 27
    n1 = n + 1
    Q_Copy(s(0, 1),one)
    If n < 2: Goto 21:EndIf
    For l = 2 To n
      Q_Copy(s(0, l),zero)
    Next
21: For l = 1 To #m
      Q_Copy(s(l, n1),zero)
    Next
22: PrintN("")
    For l = 1 To #m
      If Q_Equ(s(l, n1),zero)=0: Goto 84:EndIf
    Next
    PrintN("Enter x value at which series is to be expanded ,< press return key to end >")
    Print("> ")
    aa=Input()
    If aa = "": Goto 84:EndIf
    Q_Val(z,aa)
    Q_Copy(c(0),z)
    ClearConsole()
    Q_Copy(s(0, 0),c(0)): oo = 0: vv = 0: Q_Copy(ss,zero): j = 0: o(0) = 0: e3 = 17
23: j = j + 1: ee = e(j)
    If e3 = 6: Goto 30:EndIf
    If e3 = 15: Goto 24:EndIf
    If ee < 16: Goto 24:EndIf
    e3 = 15
    If ee = 17: Goto 23:EndIf
    oo = oo + 1
    o(oo) = 30
    Goto 23
24: If ee = 1: Goto 27:EndIf
    If ee = 2: Goto 26:EndIf
    If ee = 3: Goto 25:EndIf
    oo = oo + 1
    o(oo) = ee + 30
25: oo = oo + 1
    o(oo) = 10
    e3 = 17
    Goto 23
26: v(vv) = 0
    vv = vv + 1
    e3 = 6
    Goto 23
27: For i = 1 To #m
      If Q_Equ(s(i, n1),zero): Goto 28:EndIf
    Next
    PrintN("Stack filled")
    Goto 84
28: v(vv) = i
    vv = vv + 1
    kk = k(j)
    Q_Copy(s(i, 0),c(kk))
    If n < 1: Goto 29:EndIf
    For kk = 1 To n
      Q_Copy(s(i, kk),zero)
    Next
29: Q_Copy(s(i, n1),one)
    e3 = 6
    Goto 23
30: If ee > 24: Goto 31:EndIf
    o2 = 20
    If ee > 22: o2 = 22:EndIf
    Goto 32
31: o2 = 30
    If ee > 25: o2 = 20:EndIf
32: If o(oo) <= o2: Goto 33:EndIf
    go_sub(go_sub_stack)=78
    go_sub_stack=go_sub_stack+1
    Goto 37
78: Goto 32
33: If ee = 27: Goto 35:EndIf
    If ee = 26: Goto 34:EndIf
    oo = oo + 1
    o(oo) = ee
    e3 = 17
    Goto 23
34: If o(oo) <> 10: Goto 84:EndIf
    oo = oo - 1
    Goto 23
35: If (o(oo) <> 0) Or (vv <> 1): Goto 84:EndIf
    i = v(0)
    Q_Copy(s(i, n1),zero)
    a$=Space(2)
    PrintN("")
    Print("function   ="+a$)
    PrintN(Q_StrExp(s(i, 0), 49))
    If n < 1: Goto 36:EndIf
    l2=1
    For kk = 1 To n
      m1=Q_Cmp(s(i, kk),zero)
      If m1
        a$=Space(2)
        Print("a"+RSet(Str(kk),4))
        Print("      ="+a$)
;        PrintN(Q_StrExp(s(i, kk), 49))
        PrintN(Q_StrGen(s(i, kk),0,42))
        l2+1
        If (l2 % 20) = 0
          Input()
        EndIf
      EndIf
    Next
36: Goto 22
37: o1 = o(oo): oo = oo - 1
38: For kk = 1 To #m
      If Q_Equ(s(kk, n1),zero): Goto 39:EndIf
    Next
    Goto 84
39: Q_Copy(s(kk, n1),one)
    Q_Int(z , vv - 1)
    k2 = v(vv-1)
    Q_Copy(s(k2, n1),zero)
    If o1 >= 30: Goto 54:EndIf
    vv = vv-1
    Q_Dec(z)
    k1 = v(vv-1)
    v(vv-1) = kk
    Q_Copy(s(k1, n1),zero)
    If o1 = 21: Goto 40:EndIf
    If o1 = 22: Goto 41:EndIf
    If o1 = 23: Goto 42:EndIf
    If o1 = 24: Goto 43:EndIf
    Goto 45
40: For l = 0 To n
      Q_Add(s(k1, l),s(k2, l),s(kk, l))
    Next
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
41: For l = 0 To n
      Q_Sub(s(k1, l),s(k2, l),s(kk, l))
    Next
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
42: For l = 0 To n
      Q_Copy(z,zero)
      For m1 = 0 To l
        Q_Mul(s(k1, m1),s(k2, l - m1),x)
        Q_Add(z,x) 
      Next
      Q_Copy(s(kk, l),z)
    Next
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
43: Q_Copy(z1,s(k2, 0))
    For l = 0 To n
      Q_Copy(z,s(k1, l))
      If l = 0: Goto 44:EndIf
      For m1 = 1 To l
        Q_Mul(s(k2, m1),s(kk, l - m1),x)
        Q_Sub(z,x)
      Next
44:   Q_Div(z,z1,s(kk, l))
    Next
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
45: If n < 1: Goto 46:EndIf
    For l = 1 To n
      Q_Copy(z,s(k2, l))
      If (Q_Equ(z,zero)=0): Goto 53:EndIf
    Next
46: Q_Copy(z1,s(k1, 0))
    Q_Copy(z,s(k2, 0))
    Q_Add(z,one,z2)
    If Q_Equ(z1,zero): If Q_IsInt(z) And (Q_Cmp(z,zero)=1): Goto 49:EndIf:EndIf
    Q_Pow(z1,z,s(kk, 0));exp(ln(z1)*z)
47: If n < 1: Goto 48:EndIf
    For l = 1 To n
      Q_Copy(z,zero): Q_Copy(z3,zero)
      For m1 = 1 To l
        Q_Mul(s(kk, l - m1),s(k1, m1),z4)
        Q_Add(z3,z4,z3)
        Q_Int(m2, m1)
        Q_Mul(m2,z4,x)
        Q_Add(z,x)
      Next
      Q_Mul(z,z2,x)
      Q_Int(y,l)
      Q_Div(x,y)
      Q_Sub(x,z3)
      Q_Div(x,z1,s(kk, l))
    Next
48: go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
49: For k3 = 1 To #m
      If Q_Equ(s(k3, n1),zero): If k3 <> k2: Goto 50:EndIf:EndIf
    Next
    Goto 84
50: Q_Copy(s(kk, n1),zero)
    Q_Copy(z2,z)
    For l = 0 To n
      Q_Copy(s(kk, l),zero)
      Q_Copy(s(k3, l),s(k1, l))
    Next
    Q_Copy(s(kk, 0),one)
    k4 = kk
51: Q_Val(y,"2")
    Q_Div(z2,y,x)
    Q_Integer(x,z)
    Q_Sub(z2,z,z1)
    Q_Sub(z1,z)
    Q_Copy(z2,z)
    If Q_Equ(z1,zero): Goto 52:EndIf
    k1 = k3: Q_Int(z,k2): k2 = k4: kk = Q_toInt(z): k4 = kk
    go_sub(go_sub_stack)=79
    go_sub_stack=go_sub_stack+1
    Goto 42
79: If Q_Cmp(z2,zero)=1: Goto 52:EndIf
    Q_Copy(s(kk, n1),one)
    v(vv - 1) = kk
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
52: k1 = k3: Q_Int(z,k2): k2 = k3: kk = Q_toInt(z): k3 = kk
    go_sub(go_sub_stack)=80
    go_sub_stack=go_sub_stack+1
    Goto 42
80: Goto 51
53: v(vv) = k2
    Q_Copy(s(k2, n1),one)
    vv = vv + 1: k2 = k1
    go_sub(go_sub_stack)=81
    go_sub_stack=go_sub_stack+1
    Goto 58
81: o1 = 23
    go_sub(go_sub_stack)=82
    go_sub_stack=go_sub_stack+1
    Goto 38
82: o1 = 39
    go_sub(go_sub_stack)=83
    go_sub_stack=go_sub_stack+1
    Goto 38
83: go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
54: v(Q_toInt(z)) = kk
    If o1 <> 30: Goto 55:EndIf
    For l = 0 To n
      Q_Sub(zero,s(k2,l),s(kk,l))
      ;Q_Copy(s(kk, l),s(k2, l))
      ;Q_Negate(s(kk, l))
    Next
    go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
55: If o1 <> 39: Goto 57:EndIf
    Q_Exp(s(k2, 0),s(kk, 0))
    If n < 1: Goto 56:EndIf
    For l = 1 To n
      Q_Copy(z,zero)
      For m1 = 1 To l
        Q_Int(x,m1)
        Q_Mul(x,s(kk, l - m1))
        Q_Mul(x,s(k2, m1))
        Q_Add(z,x)
      Next
      Q_Int(x,l)
      Q_Div(z,x,s(kk, l))
    Next
56: go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
57: If o1 <> 40: Goto 61:EndIf
58: Q_Copy(z2,s(k2, 0))
    Q_LN(z2,s(kk, 0))
    If n < 1: Goto 60:EndIf
    For l = 1 To n
      Q_Copy(z,zero)
      If l = 1: Goto 59:EndIf
      For m1 = 1 To l - 1
        Q_Int(x,m1)
        Q_Mul(x,s(k2, l - m1))
        Q_Mul(x,s(kk, m1))
        Q_Add(z,x)
      Next
59: Q_Int(x,l)
    Q_Div(z,x,y)  
    Q_Sub(s(k2, l),y,x)
    Q_Div(x,z2,s(kk, l))
    Next
60: go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
61: If (o1=37) Or (o1=38) Or (o1=41) Or (o1=42) Or (o1=44) Or (o1=45): Goto 62:EndIf
    Goto 68
62: For k3 = 1 To #m
      If Q_Equ(s(k3, n1),zero): If k3 <> k2: Goto 63:EndIf:EndIf
    Next
    Goto 84
63: If ((o1 = 37) Or (o1 = 38))=0: Goto 64:EndIf
    Q_Int(z,kk): kk = k3: k3 = Q_toInt(z)
64: Q_Copy(z,s(k2, 0))
    If (o1 = 38) Or (o1 = 42) Or (o1 = 45): Goto 65:EndIf
    ; because the Sin and Cos functions don't work, we use the identity:
    ;          2 * Tan(z/2)
    ; Sin(z)= --------------
    ;         1 + Tan(z/2)^2
    ; 
    ;          1 - Tan(z/2)^2
    ; Cos(z)= ----------------
    ;          1 + Tan(z/2)^2
    ; 
    ;Q_Mul(z,half,x)
    ;Q_Tan(x,y)
    ;Q_Add(y,y,m2);m2 = 2*Tan
    ;Q_Mul(y,y,x) ;x  = Tan^2
    ;Q_Add(one,x,y)
    ;Q_Div(m2,y,s(kk, 0));    Q_Sin(z,s(kk, 0))
    ;Q_Sub(one,x,m2)
    ;Q_Div(m2,y,s(k3, 0));    Q_Cos(z,s(k3, 0))
    Q_Sin(z,s(kk,0))
    Q_Cos(z,s(k3,0))
    Q_Val(z1,"-1")
    Goto 66
65: Q_Exp(z,s(kk, 0))
    Q_Copy(x,one)
    Q_Div(x,s(kk, 0))
    Q_Sub(s(kk, 0),x,y)
    Q_Val(x,"0.5")
    Q_Mul(x,y,s(kk, 0))
    Q_Exp(z,s(k3, 0))
    Q_Copy(x,one)
    Q_Div(x,s(k3, 0))
    Q_Add(x,s(k3, 0))
    Q_Val(y,"0.5")
    Q_Mul(x,y,s(k3, 0))
    Q_Copy(z1,one)
66: If n < 1: Goto 67:EndIf
    For l = 1 To n
      Q_Copy(z,zero): Q_Copy(z2,zero)
      For m1 = 1 To l
        Q_Int(x,m1)
        Q_Mul(x,s(k2, m1),z3)
        Q_Mul(s(k3, l - m1),z3,x)
        Q_Add(z,x)
        Q_Mul(s(kk, l - m1),z3,x)
        Q_Add(z2,x)
      Next
      Q_Int(x,l)
      Q_Div(z,x,s(kk, l))
      Q_Mul(z2,z1,s(k3, l))
      Q_Div(s(k3, l),x)
    Next
67: If ((o1 = 44) Or (o1 = 45))=0
      go_sub_stack=go_sub_stack-1
      vc=go_sub(go_sub_stack)
      If vc=78: Goto 78:EndIf
      If vc=79: Goto 79:EndIf
      If vc=80: Goto 80:EndIf
      If vc=81: Goto 81:EndIf
      If vc=82: Goto 82:EndIf
      If vc=83: Goto 83:EndIf
    EndIf
    Q_Copy(s(k3, n1),one)
    v(vv) = k3
    vv = vv + 1
    o1 = 24
    Goto 38
68: If o1 <> 43: Goto 69:EndIf
    Q_Copy(z1,s(k2, 0))
    Q_Val(z2,"1.5")
    Q_Sqrt(z1,s(kk, 0))
    k1 = k2
    Goto 47
69: For k3 = 1 To #m
      If Q_Equ(s(k3, n1),zero): If k3 <> k2: Goto 70:EndIf:EndIf
    Next
    Goto 84
70: Q_Val(z1,"-1")
    If o1 = 36: Q_Copy(z1,one):EndIf
    Q_Mul(z1,s(k2, 0),s(k3, 0))
    Q_Mul(s(k3, 0),s(k2, 0))
    Q_Inc(s(k3, 0))
    If n < 1: Goto 71:EndIf
    For l = 1 To n
      Q_Copy(z,zero)
      For m1 = 0 To l
        Q_Mul(s(k2, m1),s(k2, l - m1),x)
        Q_Add(z,x)
      Next
      Q_Mul(z , z1,s(k3, l))
    Next
71: If o1 <> 36: Goto 74:EndIf
    Q_ATan(s(k2, 0),s(kk, 0))
    Q_Copy(z1 , s(k3, 0))
    If n < 1: Goto 73:EndIf
    For l = 1 To n
      Q_Copy(z,zero)
      If l = 1: Goto 72:EndIf
      For m1 = 1 To l - 1
        Q_Int(x,m1)
        Q_Mul(x,s(k3, l - m1))
        Q_Mul(x,s(kk, m1))
        Q_Add(z,x)
      Next
72:   Q_Int(x,l)
      Q_Div(z,x,y)
      Q_Sub(s(k2, l),y,x)
      Q_Div(x,z1,s(kk, l))
    Next
73: go_sub_stack=go_sub_stack-1
    vc=go_sub(go_sub_stack)
    If vc=78: Goto 78:EndIf
    If vc=79: Goto 79:EndIf
    If vc=80: Goto 80:EndIf
    If vc=81: Goto 81:EndIf
    If vc=82: Goto 82:EndIf
    If vc=83: Goto 83:EndIf
74: Q_Copy(s(k3, n1),one)
    Q_Copy(s(kk, n1),zero)
    v(vv - 1) = k3
    Q_Copy(z1 , s(k3, 0))
    Q_Sqrt(z1,s(kk, 0))
    Q_Val(z2 , "1.5")
    If n < 1: Goto 75:EndIf
    For l = 1 To n
      Q_Copy(z,zero)
      Q_Copy(z3,zero)
      For m1 = 1 To l
        Q_Mul(s(kk, l - m1) , s(k3, m1),z4)
        Q_Add(z3 , z4)
        Q_Int(x,m1)
        Q_Mul(x,z4)
        Q_Add(z,x)
      Next
      Q_Int(x,l)
      Q_Mul(z , z2,y)
      Q_Div(y,x)
      Q_Sub(y,z3)
      Q_Div(y,z1,s(kk, l))
    Next
75: Q_Copy(z1 , s(kk, 0))
    Q_ASin(s(k2, 0),s(k3, 0))
    If n < 1: Goto 77:EndIf
    For l = 1 To n
      Q_Copy(z ,zero)
      If l = 1: Goto 76:EndIf
      For m1 = 1 To l - 1
        Q_Int(x,m1)
        Q_Mul(x,s(kk, l - m1))
        Q_Mul(x,s(k3, m1))
        Q_Add(z,x)
      Next
76:   Q_Int(x,l)
      Q_Div(z,x,y)
      Q_Sub(s(k2, l),y,x)
      Q_Div(x,z1,s(k3, l))
    Next
77: If o1 = 35
      go_sub_stack=go_sub_stack-1
      vc=go_sub(go_sub_stack)
      If vc=78: Goto 78:EndIf
      If vc=79: Goto 79:EndIf
      If vc=80: Goto 80:EndIf
      If vc=81: Goto 81:EndIf
      If vc=82: Goto 82:EndIf
      If vc=83: Goto 83:EndIf
    EndIf
    Q_Val(x,"0.5")
    Q_Mul(x,pi)
    Q_Sub(s(k3, 0),x)
    o1 = 30
    Goto 38
84:

CloseConsole()
; IDE Options = PureBasic v3.94 Beta 4 (Windows - x86)
; CursorPosition = 277
; FirstLine = 262
; Folding = -
; DisableDebugger
;   EOF