
#StackSize = 100
#NumberOfFunctions = 18
#T_ADD=43 ;+
#T_SUB=45 ;-
#T_MUL=42 ;*
#T_DIV=47 ;/
#T_EXP=94 ;^
#T_SPC=32 ;space
#T_ERR=36 ;$
#T_CON=35 ;#
#T_LPR=40 ;(
#T_RPR=41 ;)
#T_FAC=33 ;!
#T_LST=64 ;@
#T_LT=60  ;less than
#T_EQ=61  ;equal
#T_GT=62  ;greater than
#T_LTE=20 ;less than or equal
#T_GTE=21 ;greater than or equal

Dim OpStack.l(#StackSize)
Dim ValStack.qfloat(#StackSize)
Dim Const.qfloat(#StackSize)
Dim f$(#NumberOfFunctions)

DefType.qfloat xlast,x,xtemp,g,g0,g1,MinusOne,y,zero,two,pi,one
DefType.l      i,p,lenFn,token,tokn,CmpFlag,Flag,ln,id,vi,nm,xInt
Exprn$="":Expr$=""
Gosub initvls
OpenConsole() 

ConsoleTitle ("FnEval test")
start1:
Q_Copy(xlast,ValStack(0))
PrintN("Enter an expression")
Print("> ")
Exprn$=Input()
PrintN("")
Gosub tokenize
lenExpr.l = Len(Expr$)
If lenExpr = 0
  Goto EvalEnd
EndIf
token_Index.l = 1
OS_Index.l = 0
VS_Index.l = 0
Gosub scan
Gosub comp
If token <> #T_SPC
  PrintN("")
  PrintN("Syntax Error"+Str(token))
  PrintN("")
EndIf
PrintN("")
PrintN("@ = "+ Q_StrExp(ValStack(0),63)); ValStack(0)
Goto start1

scan:

If token_Index > lenExpr 
  token = #T_SPC
Else
  token = Asc(Mid(expr$, token_Index, 1))
  token_Index = token_Index + 1
EndIf
;CompilerIf 0
If token_Index > lenExpr 
  ch$ = " "
Else
  ch$ = Mid(expr$, token_Index, 1)
EndIf

If (token=#T_LT)     ;if token="<"
  If ch$="="
    token=#T_LTE
    token_Index = token_Index + 1
  ElseIf ch$=" "
    token=#T_ERR
  EndIf
ElseIf (token=#T_GT)     ;if token=">"
  If ch$="="
    token=#T_GTE
    token_Index = token_Index + 1
  ElseIf ch$=" "
    token=#T_ERR
  EndIf
ElseIf (token=#T_EQ)     ;if token="="
  If ch$="<"
    token=#T_LTE
    token_Index = token_Index + 1
  ElseIf ch$=">"
    token=#T_GTE
    token_Index = token_Index + 1
  ElseIf ch$=" "
    token=#T_ERR
  EndIf
EndIf
;CompilerEndIf
Return

gamma:
Gosub factor
gamma1:
If token <> #T_FAC
  Return
EndIf
Gosub scan
If token = #T_ERR
  Return
EndIf
Q_Copy(x,ValStack(VS_Index - 1))
If token <> #T_FAC
  Gosub factorial
Else
  Gosub factorial2
EndIf
Q_Copy(ValStack(VS_Index - 1),g)
If token = #T_FAC
  Gosub scan
EndIf
Goto gamma1

expon:
Gosub gamma
expon1:
If token <> #T_EXP
  Return
EndIf
Gosub scan
Gosub gamma
If token = #T_ERR
  Return
EndIf
If token = #T_EXP
  Gosub expon
EndIf
VS_Index = VS_Index - 1
Q_Pow(ValStack(VS_Index - 1),ValStack(VS_Index))
Goto expon1

term:
Gosub expon
term1:
If (token <> #T_MUL) And (token <> #T_DIV)
  Return
EndIf
OpStack(OS_Index) = token: OS_Index = OS_Index + 1
Gosub scan
Gosub expon
OS_Index = OS_Index - 1: tokn = OpStack(OS_Index)
If tokn = #T_MUL
  If token = #T_ERR
    Return
  EndIf
  VS_Index = VS_Index - 1
  Q_Mul(ValStack(VS_Index - 1),ValStack(VS_Index))
  Goto term1
EndIf
If tokn = #T_DIV
  If token = #T_ERR
    Return
  EndIf
  VS_Index = VS_Index - 1
  Q_Div(ValStack(VS_Index - 1),ValStack(VS_Index))
  Goto term1
EndIf

unary:
If (token = #T_SUB) Or (token = #T_ADD)
  OpStack(OS_Index) = token
  OS_Index = OS_Index + 1
  Gosub scan
  Gosub term
  OS_Index = OS_Index - 1
  tokn = OpStack(OS_Index)
  If tokn <> #T_SUB
    Return
  EndIf
  If token = #T_ERR
    Return
  EndIf
  Q_Mul(ValStack(VS_Index - 1),MinusOne)
  Return
EndIf
Gosub term
Return

expr:
Gosub unary
expr1:
If (token <> #T_ADD) And (token <> #T_SUB)
  Return
EndIf
OpStack(OS_Index) = token: OS_Index = OS_Index + 1
Gosub scan
Gosub unary
OS_Index = OS_Index - 1: tokn = OpStack(OS_Index)
If tokn = #T_ADD
  If token = #T_ERR
    Return
  EndIf
  VS_Index = VS_Index - 1
  Q_Add(ValStack(VS_Index - 1) , ValStack(VS_Index))
  Goto expr1
EndIf
If tokn = #T_SUB
  If token = #T_ERR
    Return
  EndIf
  VS_Index = VS_Index - 1
  Q_Sub(ValStack(VS_Index - 1) , ValStack(VS_Index))
  Goto expr1
EndIf

comp:
Flag=0
Gosub expr
If ((token<>#T_LT) And (token<>#T_EQ) And (token<>#T_GT) And (token<>#T_LTE) And (token<>#T_GTE))
  Return
EndIf
OpStack(OS_Index)=token:OS_Index=OS_Index+1
Gosub scan
Gosub expr
OS_Index=OS_Index-1:tokn=OpStack(OS_Index)
If ((tokn=#T_LT) Or (tokn=#T_EQ) Or (tokn=#T_GT) Or (tokn=#T_LTE) Or (tokn=#T_GTE))
  If token=#T_ERR
    Return
  EndIf
  VS_Index=VS_Index-1
  CmpFlag=Q_Cmp(ValStack(VS_Index-1),ValStack(VS_Index))
  If tokn=#T_LT
    If (CmpFlag<0)
      Flag=1
    EndIf
    Q_Val(valStack(VS_Index-1),Str(Flag))
  ElseIf tokn=#T_EQ
    If (CmpFlag=0)
      Flag=1
    EndIf
    Q_Val(valStack(VS_Index-1),Str(Flag))
  ElseIf tokn=#T_GT
    If (CmpFlag>0)
      Flag=1
    EndIf
    Q_Val(valStack(VS_Index-1),Str(Flag))
  ElseIf tokn=#T_LTE
    If (CmpFlag<0) Or (CmpFlag=0)
      Flag=1
    EndIf
    Q_Val(valStack(VS_Index-1),Str(Flag))
  ElseIf tokn=#T_GTE 
    If (CmpFlag>0) Or (CmpFlag=0)
      Flag=1
    EndIf
    Q_Val(valStack(VS_Index-1),Str(Flag))
  EndIf   
EndIf
Return

factor:
If token <> #T_LST
  Goto factor3
EndIf
Q_Copy(ValStack(VS_Index),xlast): VS_Index = VS_Index + 1
Gosub scan
Return
factor3:
If token <> #T_CON
  Goto factor4
EndIf
Q_Copy(ValStack(VS_Index),const(Val(Mid(Expr$,token_Index,2))))
VS_Index = VS_Index + 1
token_Index = token_Index + 2
Gosub scan
Return
factor4:
If ((token <> #T_SUB) And (token <> #T_ADD))
  Goto factor5
EndIf
Gosub unary
Return
factor5:
If token <> #T_LPR
  Goto factor7
EndIf
Gosub scan
Gosub comp
If token = #T_RPR
  Goto factor6
EndIf
PrintN("") : PrintN("Missing ')'")
Return
factor6:
Gosub scan
Return
factor7:
tokn = token
If (tokn > 0) And (tokn <= #NumberOfFunctions)
  Goto factor8
EndIf
token = #T_ERR
Return
factor8:
Gosub scan
OpStack(OS_Index) = tokn: OS_Index = OS_Index + 1
If token = #T_LPR
  Goto factor9
EndIf
PrintN("'(' expected")
Return
factor9:
Gosub scan
Gosub comp
If token = #T_RPR
  Goto factor10
EndIf
PrintN("')' expected")
Return
factor10:
Gosub scan
OS_Index = OS_Index - 1: tokn = OpStack(OS_Index)
Q_Copy(x,ValStack(VS_Index - 1))
      Select tokn
        Case 1 ;Asinh
          Q_ASinH(ValStack(VS_Index - 1))
        Case 2 ;Acosh
          Q_ACosH(ValStack(VS_Index - 1))
        Case 3 ;Atanh
          Q_ATanH(ValStack(VS_Index - 1))
        Case 4 ;Sinh
          Q_SinH(ValStack(VS_Index - 1))
        Case 5 ;Cosh
          Q_CosH(ValStack(VS_Index - 1))
        Case 6 ;Tanh
          Q_TanH(ValStack(VS_Index - 1))
        Case 7 ;Asin
          Q_ASin(ValStack(VS_Index - 1))
        Case 8 ;Acos
          Q_ACos(ValStack(VS_Index - 1))
        Case 9 ;Atan
          Q_ATan(ValStack(VS_Index - 1))
        Case 10 ;Alog
          Q_ExpTen(ValStack(VS_Index - 1))
        Case 11 ;Sqrt
          Q_Sqrt(ValStack(VS_Index - 1))
        Case 12 ;Sin
          Q_Sin(ValStack(VS_Index - 1))
        Case 13 ;Cos
          Q_Cos(ValStack(VS_Index - 1))
        Case 14 ;Tan
          Q_Tan(ValStack(VS_Index - 1))
        Case 15 ;Log10
          Q_Log(ValStack(VS_Index - 1))
        Case 16 ;Exp
          Q_Exp(ValStack(VS_Index - 1))
        Case 17 ;x^2
          Q_Mul(ValStack(VS_Index - 1),x)
        Case 18 ;Ln
          Q_LN(ValStack(VS_Index - 1))
      EndSelect
Return

numstrip:
a$ = Expr$+" "
Expr$ = ""
ln = Len(a$)
id = 1
value$ = ""
vi = 0
numstrip1:
If (id > ln) And (value$ = "")
  Return
EndIf
If id > ln
  Gosub vl
  Goto numstrip1
EndIf
ch$ = Mid(a$, id, 1)
id = id + 1
If id<ln
  ch1$=Mid(a$, id, 1)
EndIf

If ch$="#"
  If (id+1)<ln
    ch2$=Mid(a$,id+1,1)
  EndIf
  If ch1$="E"
    Q_E(const(vi))
    s$ = Str(vi)
    vi = vi + 1
    If (Len(s$) < 2)
      s$ = "0" + s$
    EndIf
    expr$ = expr$ + "#" + s$
    value$ = ""
    id=id+1
    Goto numstrip1
  ElseIf (ch1$="P") And (ch2$="I")
    Q_PI(const(vi))
    s$ = Str(vi)
    vi = vi + 1
    If (Len(s$) < 2)
      s$ = "0" + s$
    EndIf
    expr$ = expr$ + "#" + s$
    value$ = ""
    id=id+2 
    Goto numstrip1
  EndIf
EndIf

nm = FindString(" .0123456789", ch$,1)
If nm = 1
  Goto numstrip1
EndIf
If (nm = 0) And (value$ = "")
  expr$ = expr$ + ch$
  Goto numstrip1
EndIf
If nm = 0
  If (value$ <> "") And (FindString("E", ch$,1) > 0)
    Gosub vl1
    Goto numstrip1
  EndIf
  If nm = 0
    Gosub vl
    Goto numstrip1
  EndIf
EndIf
value$ = value$ + ch$
If nm <> 2
  Goto numstrip1
EndIf
numstrip2:
If id > ln
  Goto numstrip1
EndIf
ch$ = Mid(a$, id, 1)
id = id + 1
nm = FindString(" .0123456789", ch$,1)
If (nm = 1) Or (nm = 2)
  Goto numstrip2
EndIf
If nm = 0
  If FindString("E", ch$,1) > 0
    Gosub vl1
    Goto numstrip1
  EndIf
  If nm = 0
    Gosub vl
    Goto numstrip1
  EndIf
EndIf
value$ = value$ + ch$
Goto numstrip2
Goto numstrip1
vl1:
value$ = value$ + "E"
vl0:
If id > ln
  value$ = value$ + "0"
  ch$ = ""
  Goto vl
EndIf
ch$ = Mid(a$, id, 1)
id = id + 1
nm = FindString(" +-", ch$,1)
If nm = 1
  Goto vl0
EndIf
If nm > 1
  value$ = value$ + ch$
  ch$ = Mid(a$, id, 1)
  id = id + 1
  nm = 0
EndIf
If nm = 0
  nm = FindString("0123456789", ch$,1)
  If nm = 0
    value$ = value$ + "0"
    Goto vl2
  EndIf
  value$ = value$ + ch$
  Goto vl2
  value$ = value$ + ch$ + "0"
EndIf
vl2:
If id > ln
  ch$ = ""
  Goto vl
EndIf
ch$ = Mid(a$, id, 1)
id = id + 1
nm = FindString(" 0123456789", ch$,1)
If nm = 1
  Goto vl2
EndIf
If nm = 0
  Goto vl
EndIf
Goto vl2
vl:
If FindString("0123456789", ch$,1)<>0
  value$ = value$ + ch$
EndIf
Q_Val(const(vi),value$)
s$ = Str(vi)
vi = vi + 1
If Len(s$) < 2
  s$ = "0" + s$
EndIf
Expr$ = Expr$ + "#" + s$ + ch$
value$ = ""
Return

tokenize:
Expr$ = UCase(RemoveString(Exprn$," "))
For i = 1 To #NumberOfFunctions
  f$ = f$(i)
  lenFn = Len(f$)
  f$ = f$ + "("
  p = FindString(Expr$, f$,1)
  While p <> 0
    Expr$ = Left(Expr$, p - 1) + Chr(i) + Mid(Expr$, p + lenFn,Len(Expr$)-(p + lenFn-1))
    p = FindString(Expr$, f$,1)
  Wend
Next i
Gosub numstrip
Return

initvls:
f$(1) = "ASINH"
f$(2) = "ACOSH"
f$(3) = "ATANH"
f$(4) = "SINH"
f$(5) = "COSH"
f$(6) = "TANH"
f$(7) = "ASIN"
f$(8) = "ACOS"
f$(9) = "ATAN"
f$(10) = "ALOG"
f$(11) = "SQRT"
f$(12) = "SIN"
f$(13) = "COS"
f$(14) = "TAN"
f$(15) = "LOG"
f$(16) = "EXP"
f$(17) = "SQR"
f$(18) = "LN"

Q_Int(two,2)
Q_Int(one,1)
Q_Int(MinusOne,-1)
Q_Int(zero,0)
Q_PI(pi)

Return

factorial:
Q_Factorial(x,g)
Return

factorial2:
Q_Copy(y,x)
If Q_IsInt(y)
  If Q_IsOdd(y)
    ;CompilerIf 0
    If (Q_Sign(y)=(-1))
      Q_Inc(y)
      Q_Int(g0,-2)
      Q_Div(y,g0)
      Q_Pow(MinusOne,y,g0)
      Q_Pow(two,y,g1)
      Q_Mul(g0,g1)
      Q_Factorial(y,g1)
      Q_Mul(g0,g1)
      Q_Mul(y,two)
      Q_Factorial(y,g1)
      Q_Div(g0,g1,g)      
    Else
      Q_Factorial(y,g)
      Q_iDiv(y,two,g0)
      Q_Factorial(g0,xtemp)
      Q_Pow(two,g0,g0)
      Q_Mul(g0,xtemp)
      Q_Div(g,g0)
    EndIf
  ElseIf Q_IsEven(y)
    If (Q_Sign(y)=(-1))
      Q_SetInfinity(g)
    Else
      Q_iDiv(y,two,g0)
      Q_Factorial(g0,xtemp)
      Q_Pow(two,g0,g0)
      Q_Mul(g0,xtemp,g)
    EndIf
  EndIf
Else
  Q_Div(two,pi,g0)
  Q_Mul(y,pi,g1)
  Q_Cos(g1)
  Q_Sub(one,g1,g1)
  Q_Int(xtemp,4)
  Q_Div(g1,xtemp)
  Q_Pow(g0,g1)
  Q_Div(y,two,g1)
  Q_Pow(two,g1,xtemp)
  Q_Factorial(g1)
  Q_Mul(xtemp,g1)
  Q_Mul(xtemp,g0,g)
EndIf
Return

EvalEnd:
CloseConsole()

; ExecutableFormat=Windows
; FirstLine=1
; EnableAsm
; DisableDebugger
; EOF